<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BomRevisionSearchRow StructType
 * @subpackage Structs
 */
class BomRevisionSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BomRevisionSearchRowBasic
     */
    public $basic;
    /**
     * The billOfMaterialsJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BomSearchRowBasic
     */
    public $billOfMaterialsJoin;
    /**
     * The componentJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BomRevisionComponentSearchRowBasic
     */
    public $componentJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchRowBasic
     */
    public $transactionJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for BomRevisionSearchRow
     * @uses BomRevisionSearchRow::setBasic()
     * @uses BomRevisionSearchRow::setBillOfMaterialsJoin()
     * @uses BomRevisionSearchRow::setComponentJoin()
     * @uses BomRevisionSearchRow::setTransactionJoin()
     * @uses BomRevisionSearchRow::setCustomSearchJoin()
     * @param \StructType\BomRevisionSearchRowBasic $basic
     * @param \StructType\BomSearchRowBasic $billOfMaterialsJoin
     * @param \StructType\BomRevisionComponentSearchRowBasic $componentJoin
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\BomRevisionSearchRowBasic $basic = null, \StructType\BomSearchRowBasic $billOfMaterialsJoin = null, \StructType\BomRevisionComponentSearchRowBasic $componentJoin = null, \StructType\TransactionSearchRowBasic $transactionJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setBillOfMaterialsJoin($billOfMaterialsJoin)
            ->setComponentJoin($componentJoin)
            ->setTransactionJoin($transactionJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\BomRevisionSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\BomRevisionSearchRowBasic $basic
     * @return \StructType\BomRevisionSearchRow
     */
    public function setBasic(\StructType\BomRevisionSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get billOfMaterialsJoin value
     * @return \StructType\BomSearchRowBasic|null
     */
    public function getBillOfMaterialsJoin()
    {
        return $this->billOfMaterialsJoin;
    }
    /**
     * Set billOfMaterialsJoin value
     * @param \StructType\BomSearchRowBasic $billOfMaterialsJoin
     * @return \StructType\BomRevisionSearchRow
     */
    public function setBillOfMaterialsJoin(\StructType\BomSearchRowBasic $billOfMaterialsJoin = null)
    {
        $this->billOfMaterialsJoin = $billOfMaterialsJoin;
        return $this;
    }
    /**
     * Get componentJoin value
     * @return \StructType\BomRevisionComponentSearchRowBasic|null
     */
    public function getComponentJoin()
    {
        return $this->componentJoin;
    }
    /**
     * Set componentJoin value
     * @param \StructType\BomRevisionComponentSearchRowBasic $componentJoin
     * @return \StructType\BomRevisionSearchRow
     */
    public function setComponentJoin(\StructType\BomRevisionComponentSearchRowBasic $componentJoin = null)
    {
        $this->componentJoin = $componentJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchRowBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @return \StructType\BomRevisionSearchRow
     */
    public function setTransactionJoin(\StructType\TransactionSearchRowBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $bomRevisionSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$bomRevisionSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($bomRevisionSearchRowCustomSearchJoinItem) ? get_class($bomRevisionSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($bomRevisionSearchRowCustomSearchJoinItem), var_export($bomRevisionSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\BomRevisionSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\BomRevisionSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
